/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */

package com.liferay.privatemessaging.hook.listeners;

import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.model.BaseModelListener;
import com.liferay.portal.model.User;
import com.liferay.privatemessaging.service.UserThreadLocalServiceUtil;

/**
 * @author Scott Lee
 */
public class UserListener extends BaseModelListener<User> {

	@Override
	public void onBeforeRemove(User user) {
		try {
			if (_log.isDebugEnabled()) {
				_log.debug(
					"Removing private messages for user " +
						user.getUserId());
			}

			UserThreadLocalServiceUtil.deleteUser(user.getUserId());
		}
		catch (Exception e) {
			_log.error(
				"Unable to remove private messages for user " +
					user.getUserId());
		}
	}

	private static Log _log = LogFactoryUtil.getLog(UserListener.class);

}