<%--
/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/init.jsp" %>

<%
long mbThreadId = ParamUtil.getLong(request, "mbThreadId");
%>

<c:choose>
	<c:when test="<%= !themeDisplay.isSignedIn() %>">
		<liferay-ui:message key="please-sign-in-to-use-the-private-messaging-portlet" />
	</c:when>
	<c:when test="<%= (mbThreadId != 0) && PrivateMessagingUtil.isUserPartOfThread(user.getUserId(), mbThreadId) %>">
		<aui:layout cssClass="thread">
			<%@ include file="/view_thread.jsp" %>
		</aui:layout>
	</c:when>
	<c:otherwise>
		<aui:layout cssClass="messages">
			<%@ include file="/view_messages.jsp" %>
		</aui:layout>
	</c:otherwise>
</c:choose>

<aui:script use="liferay-plugin-privatemessaging">
	Liferay.PrivateMessaging.init(
		{
			namespace: '<portlet:namespace />'
		}
	);
</aui:script>