<%--
/**
 * Copyright (c) 2000-2011 Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%
UserThreadLocalServiceUtil.markUserThreadAsRead(user.getUserId(), mbThreadId);
%>

<portlet:renderURL var="backURL" windowState="<%= WindowState.NORMAL.toString() %>" />

<liferay-ui:header
	backLabel="messages"
	backURL="<%= backURL.toString() %>"
	title="<%= HtmlUtil.escape(PrivateMessagingUtil.getThreadSubject(mbThreadId)) %>"
/>

<aui:layout cssClass="controls">
	<liferay-portlet:actionURL name="markMessagesAsUnread" var="markAsUnreadURL">
		<portlet:param name="mbThreadIds" value="<%= String.valueOf(mbThreadId) %>" />
	</liferay-portlet:actionURL>

	<aui:button href="<%= markAsUnreadURL %>" name="markAsUnread" value="mark-as-unread" />

	<liferay-portlet:actionURL name="deleteMessages" var="deleteMessageURL">
		<portlet:param name="mbThreadIds" value="<%= String.valueOf(mbThreadId) %>" />
	</liferay-portlet:actionURL>

	<aui:button href="<%= deleteMessageURL %>" name="deleteMessage" value="delete" />
</aui:layout>

<aui:layout cssClass="thread-info">
	Between

	<%
	List<User> users = PrivateMessagingUtil.getThreadUsers(user.getUserId(), mbThreadId);

	for (int i = 0; i < users.size(); i++) {
		User curUser = users.get(i);
	%>

		<c:choose>
			<c:when test="<%= LAYOUT_USER_PUBLIC_LAYOUTS_ENABLED %>">
				<liferay-portlet:actionURL portletName="<%= PortletKeys.MY_SITES %>" var="publicPagesURL">
					<portlet:param name="struts_action" value="/my_sites/view" />
					<portlet:param name="groupId" value="<%= String.valueOf(curUser.getGroup().getGroupId()) %>" />
					<portlet:param name="privateLayout" value="<%= Boolean.FALSE.toString() %>" />
				</liferay-portlet:actionURL>

				<a class="profile-link" href="<%= publicPagesURL %>"><%= curUser.getFullName() %></a>
			</c:when>
			<c:otherwise>
				<span class="profile-link"><%= curUser.getFullName() %></span>
			</c:otherwise>
		</c:choose>

		<c:if test="<%= i != (users.size() - 1) %>">
			,
		</c:if>

	<%
	}
	%>

	<c:choose>
		<c:when test="<%= LAYOUT_USER_PUBLIC_LAYOUTS_ENABLED %>">
			<liferay-portlet:actionURL portletName="<%= PortletKeys.MY_SITES %>" var="selfPublicPagesURL">
				<portlet:param name="struts_action" value="/my_sites/view" />
				<portlet:param name="groupId" value="<%= String.valueOf(user.getGroup().getGroupId()) %>" />
				<portlet:param name="privateLayout" value="<%= Boolean.FALSE.toString() %>" />
			</liferay-portlet:actionURL>

			and <a class="profile-link" href="<%= selfPublicPagesURL %>"><liferay-ui:message key="you" /></a>
		</c:when>
		<c:otherwise>
			and <span class="profile-link"><liferay-ui:message key="you" /></span>
		</c:otherwise>
	</c:choose>
</aui:layout>

<liferay-ui:search-container delta="25" emptyResultsMessage="no-messages-found">
	<liferay-ui:search-container-results>

		<%
		results = PrivateMessagingUtil.getThreadMessages(user.getUserId(), mbThreadId, searchContainer.getStart(), searchContainer.getEnd(), true);
		total = PrivateMessagingUtil.getThreadMessagesCount(user.getUserId(), mbThreadId);

		pageContext.setAttribute("results", results);
		pageContext.setAttribute("total", total);
		%>

	</liferay-ui:search-container-results>

	<liferay-ui:search-container-row
		className="com.liferay.portlet.messageboards.model.MBMessage"
		modelVar="mbMessage"
	>

		<liferay-ui:search-container-column-text valign="top">
			<liferay-ui:user-display
				userId="<%= mbMessage.getUserId() %>"
				userName="<%= mbMessage.getUserName() %>"
				displayStyle="<%= 2 %>"
			/>

			<%
			User curUser = UserLocalServiceUtil.getUser(mbMessage.getUserId());
			%>

			<div class="message">
				<c:choose>
					<c:when test="<%= LAYOUT_USER_PUBLIC_LAYOUTS_ENABLED %>">
						<liferay-portlet:actionURL portletName="<%= PortletKeys.MY_SITES %>" var="publicPagesURL">
							<portlet:param name="struts_action" value="/my_sites/view" />
							<portlet:param name="groupId" value="<%= String.valueOf(curUser.getGroup().getGroupId()) %>" />
							<portlet:param name="privateLayout" value="<%= Boolean.FALSE.toString() %>" />
						</liferay-portlet:actionURL>

						<span class="name">
							<a class="profile-link" href="<%= publicPagesURL %>"><%= HtmlUtil.escape(curUser.getFullName()) %></a>
						</span>
					</c:when>
					<c:otherwise>
						<span class="name">
							<span class="profile-link"><%= HtmlUtil.escape(curUser.getFullName()) %></span>
						</span>
					</c:otherwise>
				</c:choose>

				<span class="date">
					<%= dateFormatDateTime.format(mbMessage.getCreateDate()) %>
				</span>

				<div class="body">
					<%= HtmlUtil.escape(mbMessage.getBody()) %>

					<c:if test="<%= mbMessage.isAttachments() %>">
						<hr />

						<%
						String[] attachmentsFiles = mbMessage.getAttachmentsFiles();

						for (int j = 0; j < attachmentsFiles.length; j++) {
							String fileName = FileUtil.getShortFileName(attachmentsFiles[j]);

							if (StringUtil.endsWith(fileName, ".gif") || StringUtil.endsWith(fileName, ".jpg") || StringUtil.endsWith(fileName, ".png")) {
						%>

								<div>
									<img alt="<liferay-ui:message key="attachment" />" src="<liferay-portlet:actionURL name="getMessageAttachment" windowState="<%= LiferayWindowState.EXCLUSIVE.toString() %>"><portlet:param name="messageId" value="<%= String.valueOf(mbMessage.getMessageId()) %>" /><portlet:param name="attachment" value="<%= fileName %>" /></liferay-portlet:actionURL>" />
								</div>

								<br />

						<%
							}
						}
						%>

						<table class="lfr-table">
						<tr>
							<td class="lfr-top">
								<strong><liferay-ui:message key="attachments" />:</strong>
							</td>
							<td>

								<%
								for (int j = 0; j < attachmentsFiles.length; j++) {
									String fileName = FileUtil.getShortFileName(attachmentsFiles[j]);
									long fileSize = DLStoreUtil.getFileSize(company.getCompanyId(), CompanyConstants.SYSTEM, attachmentsFiles[j]);
								%>

									<a href="<liferay-portlet:actionURL name="getMessageAttachment" windowState="<%= LiferayWindowState.EXCLUSIVE.toString() %>"><portlet:param name="messageId" value="<%= String.valueOf(mbMessage.getMessageId()) %>" /><portlet:param name="attachment" value="<%= fileName %>" /></liferay-portlet:actionURL>"><%= fileName %></a> (<%= TextFormatter.formatKB(fileSize, locale) %>k)<%= (j < (attachmentsFiles.length - 1)) ? ", " : "" %>

								<%
								}
								%>

							</td>
						</tr>
						</table>
					</c:if>
				</div>
			</div>
		</liferay-ui:search-container-column-text>
	</liferay-ui:search-container-row>

	<liferay-ui:search-iterator />
</liferay-ui:search-container>

<aui:layout cssClass="message-body-container">
	<liferay-portlet:renderURL var="backToThreadURL" windowState="<%= WindowState.NORMAL.toString() %>"><portlet:param name="mbThreadId" value="<%= String.valueOf(mbThreadId) %>" /></liferay-portlet:renderURL>

	<form enctype="multipart/form-data" method="post" name="<portlet:namespace />fm" onSubmit="<portlet:namespace />sendPrivateMessage(); return false;">
		<aui:input name="redirect" type="hidden" value="<%= backToThreadURL %>" />
		<aui:input name="userId" type="hidden" value="<%= user.getUserId() %>" />
		<aui:input name="mbThreadId" type="hidden" value="<%= mbThreadId %>" />

		<div>
			<textarea class="message-body" name="<portlet:namespace />body"></textarea>
		</div>

		<div>
			<label class="aui-field-label">
				<liferay-ui:message key="attachments" />
			</label>

			<aui:input label="" name="msgFile1" type="file" />

			<aui:input label="" name="msgFile2" type="file" />

			<aui:input label="" name="msgFile3" type="file" />
		</div>

		<aui:button-row>
			<aui:button name="send" type="submit" value="send" />
		</aui:button-row>
	</form>
</aui:layout>

<aui:layout cssClass="controls">
	<aui:button cssClass="back-button" href="<%= backURL %>" value="back-to-messages" />
</aui:layout>

<aui:script>
	function <portlet:namespace />sendPrivateMessage() {
		submitForm(document.<portlet:namespace />fm, '<liferay-portlet:actionURL name="sendMessage" />');
	}
</aui:script>